unit UnidadComprobarEmail;

interface

uses
  dnssend, smtpsend, synautil, classes, synamisc;

function comprobarEmail (email : string) : integer;

implementation

{
0 - direccin existe
1 - direccin es posible que exista
2 - el DNS no permite la comprobacin
3 - el DNS no est definido
4 - no se puede comprobar el servidor MX
5 - el dominio no tiene registro MX
6 - la direccin no existe
7 - la sintaxis de la direccin es incorrecta
}

function comprobarEmail (email : string) : integer;
var
  smtp:TSMTPsend;
  domain:string;
  user: string;
  mailservers:tstringlist;
  dnsservers:tstringlist;
  x: integer;
  n, m: integer;
  b: boolean;
begin
  result:=7;
  email:=getemailaddr(email);
  x := pos('@', email);
  if x <= 0 then
    exit;   //formato de la direccin incorrecto
  domain:=separateright(email,'@');
  user:=separateLeft(email,'@');
  if (domain = '') or (user = '') then
    exit;  //formato de la direccin incorrecto
  smtp:=tsmtpsend.create;
  mailservers:=tstringlist.create;
  dnsservers:=tstringlist.create;
  try
    dnsservers.CommaText := GetDNS;
    result := 3;
    if dnsservers.Count = 0 then
      Exit; // no hay servidor DNS definido
    result := 2;
    b := false;
    for n := 0 to dnsservers.Count -1 do
      if GetMailServers(dnsservers[n], domain, mailservers) then
      begin
        b := true;
        break;
      end;
    if not b then
      Exit;  // no se puede contactar con el servidor DNS
    result := 5;
    if mailservers.Count = 0 then
      exit;   // no hay registro MX para el dominio indicado
    b := false;
    for n := 0 to mailservers.count - 1 do
    begin
      smtp.TargetHost := mailservers[n];
      if not smtp.Login then
        Continue;
      b := true;
      if smtp.Verify(email) then
      begin
        if smtp.ResultCode < 252 then
        begin
          Result := 0; // confirmada la direccin del usuario
          break;
        end;
      end
      else
        if smtp.ResultCode = 551 then
        begin
          Result := 6; // no confirmada la direccin del usuario
          break;
        end;
      if not smtp.MailFrom('mailcheck@somewhere.com', 100) then
        Continue;
      if not smtp.MailTo(email) then
      begin
        Result := 6;  // direccin del usuario no confirmada
        break;
      end
      else
      begin
        Result := 1;  // la direccin es posible que exista
        break;
      end;
    end;
    if not b then
      result := 4;   //no se puede contactar con el servidor
  finally
    dnsservers.free;
    mailservers.free;
    smtp.free;
  end;
end;

end.
